/***************************************************************************
                          sqlgui.cpp  -  description
                             -------------------
    begin                : Sat Apr 14 18:28:06 CEST 2001
    copyright            : (C) 2001 by mb
    email                : marcus@beranek.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

// include files for QT
#include <qdir.h>
#include <qprinter.h>
#include <qpainter.h>
#include <kurl.h>

// include files for KDE
#include <kiconloader.h>
#include <kmessagebox.h>
#include <kfiledialog.h>
#include <kmenubar.h>
#include <kapp.h>
#include <klocale.h>
#include <kconfig.h>
#include <kstdaction.h>
#include <kstatusbar.h>


// application specific includes
#include "sqlgui.h"
#include "sqlguiview.h"
#include "sqlguidoc.h"
#include <klineeditdlg.h>

//#include "login.h"
#include "loginbox.h"

#include <qmessagebox.h> 
#include <qnamespace.h>

//#include "create_table.h"
#include "tablegenerator.h"
//#include "create_base.h"
#include "basecreator.h"

//#include "waiter.h"

#include <iostream>
#include <iomanip>

#define ID_STATUS_MSG 1

SqlGuiApp::SqlGuiApp(QWidget* , const char* name):KMainWindow(0, name)
{
  config=kapp->config();

  ///////////////////////////////////////////////////////////////////
  // call inits to invoke all other construction parts
  initActions();
  initStatusBar();
  initDocument();
	
  readOptions();
  initView();

  connect( doc, SIGNAL( DbQueryError( QString* ) ), this, SLOT( slotDisplayErrorMsg(QString *) ) );
  connect( doc, SIGNAL( connectionChanged() ), view, SLOT( slotUpdateMainView() ) );
  connect( view, SIGNAL( doQuery(QString*, QString*) ), doc, SLOT( slotDoQuery(QString*, QString* )  )  );
  connect( doc, SIGNAL( resultChanged() ), view, SLOT( slotUpdateResultList() ) );
  connect( doc, SIGNAL( lastActionChanged( QString*, QString*, QString* ) ), view, SLOT( slotUpdateLastAction( QString*, QString*, QString* ) ) );
  connect( view, SIGNAL( createTable() ), this,  SLOT( slotFileNew() ));
  connect( view, SIGNAL( createDb() ), this,  SLOT( slotBaseNew() ));
  connect( view, SIGNAL( deleteDb( QString* ) ), doc,  SLOT( slotDbDelete( QString* ) ));
  connect( view, SIGNAL( deleteTable( QString*, QString* ) ), doc,  SLOT( slotTableDelete( QString*, QString* ) ));
  connect( view, SIGNAL( checkTable( QString*, QString* ) ), doc,  SLOT( slotTableCheck( QString*, QString* ) ));
  connect( view, SIGNAL( optimizeTable( QString*, QString* ) ), doc,  SLOT( slotTableOptimize( QString*, QString* ) ));
  connect( view, SIGNAL( repairTable( QString*, QString* ) ), doc,  SLOT( slotTableRepair( QString*, QString* ) ));
  connect( view, SIGNAL( gotResult() ), doc,  SLOT( slotClearMemory() ));


  ///////////////////////////////////////////////////////////////////
  // disable actions at startup
  fileSave->setEnabled(true);
  fileSaveAs->setEnabled(true);
  filePrint->setEnabled(false);
  editCut->setEnabled(false);
  editCopy->setEnabled(false);
  editPaste->setEnabled(false);

//  slotFileOpenRecent("http://nobody@192.168.12.1");
}

SqlGuiApp::~SqlGuiApp()
{

}


void SqlGuiApp::slotDocReConnect()
{
  doc->slotReConnect();
}

void SqlGuiApp::slotShowWaiter(){
//	waiting_guy->show();
	//emit waiterComplete();
}

void SqlGuiApp::slotHideWaiter(){
//	waiting_guy->hide();
////	delete waiting_guy;
}


void SqlGuiApp::slotDeleteTableRequest()
{
  view->deleteTable();
}

void SqlGuiApp::slotDeleteBaseRequest()
{
  view->deleteBase();
}

void SqlGuiApp::initActions()
{

  fileNewBase = new KAction(i18n("Create &Base"), "filenew", 0, this, SLOT(slotBaseNew()), actionCollection(), "file_create_base");
  fileReConnect = new KAction(i18n("&Reconnect"), "reload", 0, this, SLOT(slotDocReConnect()), actionCollection(), "file_reconnect_base");
  fileNewWindow = new KAction(i18n("New Window"), "filenew", 0, this, SLOT(slotFileNewWindow()), actionCollection(),"file_new_window");
  fileNew = new KAction(i18n("Create &Table"), "filenew", 0, this, SLOT(slotFileNew()), actionCollection(), "file_create_table");
//  fileOpen = new KAction(i18n("&Open Host"), 0, 0, this, SLOT(slotFileOpen()), actionCollection(),"file_open_host");
  fileDeleteTable = new KAction(i18n("Delete Table"), "fileclose", 0, this, SLOT(slotDeleteTableRequest()), actionCollection(), "file_delete_table");
  fileDeleteBase = new KAction(i18n("Delete Base"), "fileclose", 0, this, SLOT(slotDeleteBaseRequest()), actionCollection(),"file_delete_base");


//  fileNewBase = KStdAction::revert(this, SLOT(slotBaseNew()), actionCollection());
//  fileReConnect = KStdAction::redisplay( this, SLOT(slotDocReConnect()), actionCollection());
//  fileNew = KStdAction::openNew(this, SLOT(slotFileNew()), actionCollection()); // new table
  fileOpen = KStdAction::open(this, SLOT(slotFileOpen()), actionCollection());  // open host
  fileOpen->setText(i18n("&Open host"));

  fileOpenRecent = KStdAction::openRecent(this, SLOT(slotFileOpenRecent(const KURL&)), actionCollection());

  fileSave = KStdAction::save(this, SLOT(slotFileSave()), actionCollection());
  fileSaveAs = KStdAction::saveAs(this, SLOT(slotFileSaveAs()), actionCollection());
  fileClose = KStdAction::close(this, SLOT(slotFileClose()), actionCollection());
  filePrint = KStdAction::print(this, SLOT(slotFilePrint()), actionCollection());
  fileQuit = KStdAction::quit(this, SLOT(slotFileQuit()), actionCollection());
  editCut = KStdAction::cut(this, SLOT(slotEditCut()), actionCollection());
  editCopy = KStdAction::copy(this, SLOT(slotEditCopy()), actionCollection());
  editPaste = KStdAction::paste(this, SLOT(slotEditPaste()), actionCollection());
  viewToolBar = KStdAction::showToolbar(this, SLOT(slotViewToolBar()), actionCollection());
  viewStatusBar = KStdAction::showStatusbar(this, SLOT(slotViewStatusBar()), actionCollection());

  fileNewWindow->setStatusText(i18n("Opens a new application window"));
  fileNew->setStatusText(i18n("Creates a new table"));
  fileOpen->setStatusText(i18n("Opens a connection to a mysql-host"));
  fileOpenRecent->setStatusText(i18n("Opens a recently used file"));
  fileSave->setStatusText(i18n("Saves the actual document"));
  fileSaveAs->setStatusText(i18n("Saves the actual document as..."));
  fileClose->setStatusText(i18n("Closes the actual document"));
  filePrint ->setStatusText(i18n("Prints out the actual document"));
  fileQuit->setStatusText(i18n("Quits the application"));
  editCut->setStatusText(i18n("Cuts the selected section and puts it to the clipboard"));
  editCopy->setStatusText(i18n("Copies the selected section to the clipboard"));
  editPaste->setStatusText(i18n("Pastes the clipboard contents to actual position"));
  viewToolBar->setStatusText(i18n("Enables/disables the toolbar"));
  viewStatusBar->setStatusText(i18n("Enables/disables the statusbar"));

  // use the absolute path to your sqlguiui.rc file for testing purpose in createGUI();
//  QString *xmlfile = new QString("/home/yogi/Projekte/sqlgui_0.2/sqlgui/sqlguiui.rc");
//  createGUI( *xmlfile );
  createGUI();

}

void SqlGuiApp::initStatusBar()
{
  ///////////////////////////////////////////////////////////////////
  // STATUSBAR
  // TODO: add your own items you need for displaying current application status.
  statusBar()->insertItem(i18n("Ready."), ID_STATUS_MSG);
}

void SqlGuiApp::initDocument()
{
  doc = new SqlGuiDoc(this);
  doc->newDocument();
}

void SqlGuiApp::initView()
{ 
  ////////////////////////////////////////////////////////////////////
  // create the main widget here that is managed by KTMainWindow's view-region and
  // connect the widget to your document to display document contents.

  view = new SqlGuiView(this);
//	waiting_guy = new Waiter(this,"Stop",false,0);
  doc->addView(view);
  setCentralWidget(view);	
  setCaption(doc->URL().fileName(),false);
//  waiting_guy->hide();
}

void SqlGuiApp::openDocumentFile(const KURL& url)
{
  slotStatusMsg(i18n("Connecting to MySQL-Host..."));

//  doc->openDocument( url);

  fileOpenRecent->addURL( url );
  slotStatusMsg(i18n("Ready."));
}


SqlGuiDoc *SqlGuiApp::getDocument() const
{
  return doc;
}

SqlGuiView *SqlGuiApp::getView() const
{
  return view;
}

void SqlGuiApp::saveOptions()
{	
  config->setGroup("General Options");
  config->writeEntry("Geometry", size());
  config->writeEntry("Show Toolbar", viewToolBar->isChecked());
  config->writeEntry("Show Statusbar",viewStatusBar->isChecked());
  config->writeEntry("ToolBarPos", (int) toolBar("mainToolBar")->barPos());
//  fileOpenRecent->saveEntries(config,"Recent Files");
  fileOpenRecent->saveEntries(config);
}


void SqlGuiApp::readOptions()
{
	
  config->setGroup("General Options");

  // bar status settings
  bool bViewToolbar = config->readBoolEntry("Show Toolbar", true);
  viewToolBar->setChecked(bViewToolbar);
  slotViewToolBar();

  bool bViewStatusbar = config->readBoolEntry("Show Statusbar", true);
  viewStatusBar->setChecked(bViewStatusbar);
  slotViewStatusBar();


  // bar position settings
  KToolBar::BarPosition toolBarPos;
  toolBarPos=(KToolBar::BarPosition) config->readNumEntry("ToolBarPos", KToolBar::Top);
  toolBar("mainToolBar")->setBarPos(toolBarPos);
	
  // initialize the recent file list
//  fileOpenRecent->loadEntries(config,"Recent Files");
  fileOpenRecent->loadEntries(config);

  QSize size=config->readSizeEntry("Geometry");
  if(!size.isEmpty())
  {
    resize(size);
  } else
  {
		resize( QSize::QSize(750,550) );
  }
}

void SqlGuiApp::saveProperties(KConfig *_cfg)
{
  if(doc->URL().fileName()!=i18n("Untitled") && !doc->isModified())
  {
    // saving to tempfile not necessary

  }
  else
  {
    KURL url=doc->URL();	
    _cfg->writeEntry("filename", url.url());
    _cfg->writeEntry("modified", doc->isModified());
    QString tempname = kapp->tempSaveName(url.url());
    QString tempurl= KURL::encode_string(tempname);
    KURL _url(tempurl);
    doc->saveDocument(_url);
  }
}


void SqlGuiApp::readProperties(KConfig* _cfg)
{
  QString filename = _cfg->readEntry("filename", "");
  KURL url(filename);
  bool modified = _cfg->readBoolEntry("modified", false);
  if(modified)
  {
    bool canRecover;
    QString tempname = kapp->checkRecoverFile(filename, canRecover);
    KURL _url(tempname);
  	
    if(canRecover)
    {
//      doc->openDocument(_url);
      doc->setModified();
      setCaption(_url.fileName(),true);
      QFile::remove(tempname);
    }
  }
  else
  {
    if(!filename.isEmpty())
    {
//      doc->openDocument(url);
      setCaption(url.fileName(),false);
    }
  }
}		

bool SqlGuiApp::queryClose()
{
//  return doc->saveModified();
return true;
}

bool SqlGuiApp::queryExit()
{
  saveOptions();
  return true;
}

/////////////////////////////////////////////////////////////////////
// SLOT IMPLEMENTATION
/////////////////////////////////////////////////////////////////////

void SqlGuiApp::slotDisplayErrorMsg(QString * msg)
{
  QMessageBox::information( this, i18n( "ERROR" ), i18n( msg->latin1() ) );
}

void SqlGuiApp::slotFileNewWindow()
{
  slotStatusMsg(i18n("Opening a new application window..."));
	
  SqlGuiApp *new_window= new SqlGuiApp();
  new_window->show();

  slotStatusMsg(i18n("Ready."));
}

void SqlGuiApp::slotFileNew()
{
  slotStatusMsg(i18n("Creating new table..."));

  tableGenerator *tGen = new tableGenerator(view->selectedDB() );
  tGen->show();

  connect( tGen, SIGNAL( createTableRequest( QString*, QString* ) ), doc, SLOT(slotDoQuery(QString*, QString* )) );

  slotStatusMsg(i18n("Ready."));
}

void SqlGuiApp::slotBaseNew()
{
  slotStatusMsg(i18n("Creating new base..."));

  cout << "SQLGUI: Request for creating base " << endl;

  baseCreator *bGen = new baseCreator(this);
  bGen->show();
  slotStatusMsg(i18n("Ready."));
  connect( bGen, SIGNAL( createRequest( QString* ) ), doc, SLOT( slotDbCreate( QString* ) ) );
}

void SqlGuiApp::slotFileOpen()
{
  slotStatusMsg(i18n("Opening file..."));
	
  if(!doc->saveModified())
  {
     // here saving wasn't successful

  }
  else
  {	
    //Login_box * log_box;
    //log_box = new Login_box( this, "Login_box", false, 0 );
    LoginBox * log_box;
    log_box = new LoginBox( this, "Login_box", false, 0 );
    log_box->show();
  	setCaption(i18n("Connected"), false);
    connect( log_box, SIGNAL( loginRequest( QString, QString, QString )  ), doc, SLOT( slotDoLogin( QString, QString, QString )  ) );
    connect( log_box, SIGNAL( loginRequest( QString, QString, QString )  ), this, SLOT( slotAddConn()  ) );
  }
}

void SqlGuiApp::slotFileOpenRecent(const KURL& _url)
{
	slotStatusMsg(i18n("Opening file..."));
 	
	
 	QString u = _url.user();
 	QString h = _url.host();
    unsigned short int po = _url.port();
 	QString p = _url.pass();

	cout << endl << endl;		
	cout << "KURL: " << _url.url().latin1() << endl;		
	cout << "recent user: " << u.latin1() << endl;
	cout << "recent host: " << h.latin1() << endl;
	cout << "recent port: " << po << endl;
	cout << "recent pass: " << p.latin1() << endl << endl;

    if (po > 0){
        h.append(":");
        QString pnum;
        pnum.setNum( po );
        h.append( pnum );
    }

	//Login_box * box;
	//box = new Login_box( this, "LoginBox", false, 0, h, u );
	LoginBox * box;
	box = new LoginBox( this, "LoginBox", false, 0, h, u );


  box->show();
	setCaption(i18n("Connected"), false);
  connect( box, SIGNAL( loginRequest( QString, QString, QString )  ), doc, SLOT( slotDoLogin( QString, QString, QString )  ) );
//  connect( box, SIGNAL( loginRequest( QString, QString, QString )  ), this, SLOT( slotAddConn()  ) );

  slotStatusMsg(i18n("Ready."));
}

void SqlGuiApp::slotFileSave()
{
  slotStatusMsg(i18n("Saving file..."));
//  doc->saveDocument(doc->URL());
  view->slotExport();
  slotStatusMsg(i18n("Ready."));
}

void SqlGuiApp::slotFileSaveAs()
{
  slotStatusMsg(i18n("Saving file with a new filename..."));
  view->slotExport();

//  KURL url=KFileDialog::getSaveURL(QDir::currentDirPath(),i18n("*|All files"), this, i18n("Save as..."));
//  if(!url.isEmpty())
//    {
//      doc->saveDocument(url);
//      setCaption(url.fileName(),doc->isModified());
//    }
  
  slotStatusMsg(i18n("Ready."));
}

void SqlGuiApp::slotAddConn(){
   	KURL  rec_entry;
   	rec_entry.setUser( doc->getUser() );
   	rec_entry.setHost( doc->getHost() );
    rec_entry.setPort( doc->getPort() );
    /*
     * Note: KDE seems to strip away all passwords from URLs when adding them to the
     * recent-files-dialog. You may enable this, by exporting CXXFLAGS=SAVEPASSINSECURE,
     * but it won't give you the passwords back, if KDE doesn't allow it... :(
     *
     */
    #ifdef SAVEPASSINSECURE	
    rec_entry.setPass( doc->getPass() );
    #endif
   	rec_entry.setProtocol( "mysql" );
    if ( rec_entry.isValid() )fileOpenRecent->addURL( rec_entry );
    cout << "URL: " << rec_entry.url().latin1() << endl;
}

void SqlGuiApp::slotFileClose()
{
  slotStatusMsg(i18n("Closing file..."));
  cout << "slotFileClose..." << endl;

  doc->slotClearMemory();
  view->slotUpdateResultList();
  close();
}

void SqlGuiApp::slotFilePrint()
{
  slotStatusMsg(i18n("Printing..."));

  QPrinter printer;
  if (printer.setup(this))
  {
    view->print(&printer);
  }

  slotStatusMsg(i18n("Ready."));
}

void SqlGuiApp::slotFileQuit()
{
  slotStatusMsg(i18n("Exiting..."));
  cout << "slotFileQuit..." << endl;
  saveOptions();
  cout << "slotFileQuit: Options saved..." << endl;
  // close the first window, the list makes the next one the first again.
  // This ensures that queryClose() is called on each window to ask for closing
  KMainWindow* w;
  if(memberList)
  {
    for(w=memberList->first(); w!=0; w=memberList->first())
    {
      // only close the window if the closeEvent is accepted. If the user presses Cancel on the saveModified() dialog,
      // the window and the application stay open.
      if(!w->close())
	break;
    }
  }	
}

void SqlGuiApp::slotEditCut()
{
  slotStatusMsg(i18n("Cutting selection..."));

  slotStatusMsg(i18n("Ready."));
}

void SqlGuiApp::slotEditCopy()
{
  slotStatusMsg(i18n("Copying selection to clipboard..."));

  slotStatusMsg(i18n("Ready."));
}

void SqlGuiApp::slotEditPaste()
{
  slotStatusMsg(i18n("Inserting clipboard contents..."));

  slotStatusMsg(i18n("Ready."));
}

void SqlGuiApp::slotViewToolBar()
{
  slotStatusMsg(i18n("Toggling toolbar..."));
  ///////////////////////////////////////////////////////////////////
  // turn Toolbar on or off
  if(!viewToolBar->isChecked())
  {
    toolBar("mainToolBar")->hide();
  }
  else
  {
    toolBar("mainToolBar")->show();
  }		

  slotStatusMsg(i18n("Ready."));
}

void SqlGuiApp::slotViewStatusBar()
{
  slotStatusMsg(i18n("Toggle the statusbar..."));
  ///////////////////////////////////////////////////////////////////
  //turn Statusbar on or off
  if(!viewStatusBar->isChecked())
  {
    statusBar()->hide();
  }
  else
  {
    statusBar()->show();
  }

  slotStatusMsg(i18n("Ready."));
}


void SqlGuiApp::slotStatusMsg(const QString &text)
{
  ///////////////////////////////////////////////////////////////////
  // change status message permanently
  statusBar()->clear();
  statusBar()->changeItem(text, ID_STATUS_MSG);
}

